local MER, E, L, V, P, G = unpack(select(2, ...))
local MERS = MER:GetModule('muiSkins')
local B = E:GetModule('Blizzard')

-- Cache global variables
-- Lua functions
local _G = _G
local select = select
local format = string.format
-- WoW API / Variables
local GetNumQuestLogEntries = GetNumQuestLogEntries
local GetQuestLogTitle = GetQuestLogTitle
local hooksecurefunc = hooksecurefunc
local InCombatLockdown = InCombatLockdown
local CreateFrame = CreateFrame
-- GLOBALS

local LE_QUEST_FREQUENCY_DAILY = LE_QUEST_FREQUENCY_DAILY or 2

local function Showlevel(self)
	local numEntries = GetNumQuestLogEntries()

	for i = 1, _G.QUESTS_DISPLAYED, 1 do
		local questIndex = i + FauxScrollFrame_GetOffset(_G.QuestLogListScrollFrame)
		local questLogTitle = _G["QuestLogTitle"..i]
		local questCheck = _G["QuestLogTitle"..i.."Check"]

		if questIndex <= numEntries then
			local questLogTitleText, level, _, isHeader, _, isComplete, frequency = GetQuestLogTitle(questIndex)
			if not isHeader then
				questLogTitleText = "["..level.."] "..questLogTitleText
				if isComplete then
					questLogTitleText = "|cff68FF00"..questLogTitleText
				elseif frequency == LE_QUEST_FREQUENCY_DAILY then
					questLogTitleText = "|cff3399ff"..questLogTitleText
				end
				questLogTitle:SetText(questLogTitleText)
				questCheck:SetPoint("LEFT", questLogTitle, questLogTitle:GetWidth()-22, 0)
			end
		end
	end
end

function B:QUEST_LOG_UPDATE()
	local questNum, o
	if not InCombatLockdown() then
		questNum = select(2, GetNumQuestLogEntries())

		if questNum >= (_G.MAX_QUESTS - 5) then -- go red
			o = format("|cffff0000%d/%d|r %s", questNum, _G.MAX_QUESTS, _G.OBJECTIVES_TRACKER_LABEL)
		else
			o = format("%d/%d %s", questNum, _G.MAX_QUESTS, _G.OBJECTIVES_TRACKER_LABEL)
		end

		self.HeaderText:SetText(o)
	end
end

function B:CreateHeaderPanels()
	local HeaderBar = CreateFrame("StatusBar", nil, _G.QuestWatchFrame)
	local HeaderText = HeaderBar:CreateFontString(nil, "OVERLAY")

	HeaderBar:SetFrameStrata("LOW")
	HeaderBar:SetPoint("TOPLEFT", _G.QuestWatchFrame, 0, -4)
	HeaderBar:SetSize(160, 2)
	MERS:SkinPanel(HeaderBar)

	HeaderText:SetFontObject(GameFontNormal)
	HeaderText:SetTextColor(NORMAL_FONT_COLOR.r, NORMAL_FONT_COLOR.g, NORMAL_FONT_COLOR.b)
	HeaderText:Point("LEFT", HeaderBar, "LEFT", -2, 14)

	-- Change font of watched quests
	for i = 1, 30 do
		local Line = _G["QuestWatchLine"..i]

		Line:FontTemplate()
	end

	self.HeaderBar = HeaderBar
	self.HeaderText = HeaderText
end

hooksecurefunc(B, "QuestWatchFrame", function(self)
	if not E.private.skins.blizzard.enable or not E.private.muiSkins.blizzard.QuestWatchFrame then return end

	if not self.Skinned then
		hooksecurefunc("QuestLog_Update", Showlevel)

		B:CreateHeaderPanels()
		B:QUEST_LOG_UPDATE()

		self.Skinned = true
	end
end)
